%{
  #include "ast.tab.h"
  #include "error.h"
%}

%%

[0-9]+ {
  errno = 0;
  int64_t val = (int64_t) strtoll(yytext, NULL, 10);
  if (errno == ERANGE) {
    error(ERROR_LEXING_OVERFLOW);
  }

  yylval.value = val;
  return NUMBER;
}

"+"   { return PLUS; }
"-"   { return MINUS; }
"*"   { return TIMES; }
"/"   { return DIVIDE; }
"**"  { return POWER; }
"("   { return LPARENTHESIS; }
")"   { return RPARENTHESIS; }

[ \t] ;
. {
  error(ERROR_LEXING_UNKNOWN);
}
%%

int yywrap(void)
{
  return 1;
}
